## $Id: utils.py 17116 2022-10-05 08:26:06Z henrik $
##
## Copyright (C) 2012 Uli Fouquet & Henrik Bettermann
## This program is free software; you can redistribute it and/or modify
## it under the terms of the GNU General Public License as published by
## the Free Software Foundation; either version 2 of the License, or
## (at your option) any later version.
##
## This program is distributed in the hope that it will be useful,
## but WITHOUT ANY WARRANTY; without even the implied warranty of
## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
## GNU General Public License for more details.
##
## You should have received a copy of the GNU General Public License
## along with this program; if not, write to the Free Software
## Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
##
"""Customize general helper utilities for Kofa.
"""
from copy import deepcopy
from kofacustom.nigeria.utils.utils import NigeriaKofaUtils

class CustomKofaUtils(NigeriaKofaUtils):
    """A collection of methods subject to customization.
    """

    PAYMENT_CATEGORIES = {
        'schoolfee': 'School Fee',
        'clearance': 'Acceptance Fee',
        'bed_allocation': 'Bed Reservation',
        'hostel_maintenance': 'Hostel Fee',
        #'transfer': 'Transfer Fee',
        #'gown': 'Gown Hire Fee',
        'application': 'Application Fee',
        #'app_balance': 'Application Fee Balance',
        #'transcript': 'Transcript Fee',
        #'late_registration': 'Late Course Registration Fee',
        #'combi': 'Combi Payment',
        }

    SELECTABLE_PAYMENT_CATEGORIES = {
        'schoolfee': 'School Fee',
        'clearance': 'Acceptance Fee',
        #'bed_allocation': 'Bed Reservation (free of charge)',
        'hostel_maintenance': 'Hostel Fee',
        }

    def selectable_payment_categories(self, student):
        return self.SELECTABLE_PAYMENT_CATEGORIES

    PREVIOUS_PAYMENT_CATEGORIES = deepcopy(SELECTABLE_PAYMENT_CATEGORIES)

    COURSE_CATEGORY_DICT = {
        'C':'Core Course (C)',
        'R':'Required Courses (R)',
        'E':'Elective Courses (E)',
        }
        
    STUDY_MODES_DICT = {
        'ug_ft': 'Undergraduate Full Time',
        'found': 'Foundation',
        'dp_ft': 'Full-Time Diploma Programmes',
        'dp_pt': 'Part-Time Diploma Programmes',
        }

    APP_CATS_DICT = {
        'basic': 'UAS, PUTME, PUDE, PCE, PRENCE',
        'no': 'No Application',
        'pre': 'Pre-Degree Studies',
        'jupeb': 'JUPEB Pre-Degree (Foundation) Studies',
        'dp_ft': 'Full-Time Diploma Programmes',
        'dp_pt': 'Part-Time Diploma Programmes',
        'de': 'Direct Entry Programmes',
        }

